ZWParser Class Reference

the main class to read a ZWrite file More...

`#include <ZWParser.hxx>`

Inheritance diagram for ZWParser:

## Public Member Functions

| ZWParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor More...
virtual | ~ZWParser ()
| destructor More...
bool | checkHeader (MWAWHeader *header, bool strict=false)
| checks if the document header is correct (or not) More...
void | parse (WPXDocumentInterface *documentInterface)
| virtual function used to parse the input More...
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor More...
int | version () const
| returns the works version More...
void | setVersion (int vers)
| sets the works version More...

## Protected Member Functions

void | init ()
| inits all internal variables More...
void | createDocument (WPXDocumentInterface *documentInterface)
| creates the listener which will be associated to the document More...
Vec2f | getPageLeftTop () const
| returns the page left top point ( in inches) More...
void | newPage (int number)
| adds a new page More...
bool | sendHeaderFooter (bool header)
| try to send the header/footer More...
bool | createZones ()
| finds the different objects zones More...
bool | readBarState (MWAWEntry const &entry)
| read the bar state More...
bool | readHTMLPref (MWAWEntry const &entry)
| read the html export pref More...
bool | readPrintInfo (MWAWEntry const &entry)
| read a PrintInfo block More...
bool | readCPRT (MWAWEntry const &entry)
| try to read a xml printinfo zone More...
bool | readSectionRange (MWAWEntry const &entry)
| read the section range block More...
bool | readWindowPos (MWAWEntry const &entry)
| read the window position More...
bool | readUnknownZone (MWAWEntry const &entry)
| read a unknown block More...
bool | readCPos (MWAWEntry const &entry)
| read a cursor position in a section? More...
bool | readSLen (MWAWEntry const &entry)
| read a section length ? More...
bool | getFieldList (MWAWEntry const &entry, std::vector< ZWField > &list)
| returns a list of field More...
MWAWInputStreamPtr | rsrcInput ()
| return the input input More...
libmwaw::DebugFile & | rsrcAscii ()
| a DebugFile used to write what we recognize when we parse the document in rsrc More...
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWParser (MWAWParserStatePtr state)
| constructor using a state More...
MWAWParserStatePtr | getParserState ()
| returns the parser state More...
MWAWHeader * | getHeader ()
| returns the header More...
MWAWInputStreamPtr & | getInput ()
| returns the actual input More...
MWAWContentListenerPtr & | getListener ()
| returns the listener More...
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension More...
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension More...
double | getFormLength () const
| returns the form length More...
double | getFormWidth () const
| returns the form width More...
double | getPageLength () const
| returns the page length (form length without margin ) More...
double | getPageWidth () const
| returns the page width (form width without margin ) More...
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser More...
void | setListener (MWAWContentListenerPtr &listener)
| sets the listener More...
void | resetListener ()
| resets the listener More...
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter More...
void | setFontConverter (MWAWFontConverterPtr fontConverter)
| sets the font convertor More...
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document More...
void | setAsciiName (char const *name)
| Debugging: change the default ascii file. More...
std::string const & | asciiName () const
| return the ascii file name More...

## Protected Attributes

shared_ptr < ZWParserInternal::State > | m_state
| the state More...
shared_ptr< ZWText > | m_textParser
| the text parser More...

## Friends

class | ZWParserInternal::SubDocument
class | ZWText

## Detailed Description

the main class to read a ZWrite file

## Constructor & Destructor Documentation

ZWParser::ZWParser | ( | MWAWInputStreamPtr | input,
|  | MWAWRSRCParserPtr | rsrcParser,
|  | MWAWHeader * | header
| ) |  |

constructor

ZWParser::~ZWParser | ( |  | ) |

virtual

destructor

## Member Function Documentation

bool ZWParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = `false`
| ) |  |

virtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by parse().

void ZWParser::createDocument | ( | WPXDocumentInterface * | documentInterface | ) |

protected

creates the listener which will be associated to the document

Referenced by parse().

bool ZWParser::createZones | ( |  | ) |

protected

finds the different objects zones

Referenced by parse().

bool ZWParser::getFieldList | ( | MWAWEntry const & | entry,
|  | std::vector< ZWField > & | list
| ) |  |

protected

returns a list of field

Referenced by readBarState(), readCPos(), ZWText::readHFZone(), readHTMLPref(), readPrintInfo(), readSLen(), ZWText::readStyles(), readUnknownZone(), and readWindowPos().

Vec2f ZWParser::getPageLeftTop | ( |  | ) | const

protected

returns the page left top point ( in inches)

void ZWParser::init | ( |  | ) |

protected

inits all internal variables

Referenced by ZWParser().

void ZWParser::newPage | ( | int | number | ) |

protected

adds a new page

Referenced by ZWText::sendText().

void ZWParser::parse | ( | WPXDocumentInterface * | documentInterface | ) |

virtual

virtual function used to parse the input

Implements MWAWParser.

bool ZWParser::readBarState | ( | MWAWEntry const & | entry | ) |

protected

read the bar state

Referenced by createZones().

bool ZWParser::readCPos | ( | MWAWEntry const & | entry | ) |

protected

read a cursor position in a section?

Referenced by createZones().

bool ZWParser::readCPRT | ( | MWAWEntry const & | entry | ) |

protected

try to read a xml printinfo zone

Referenced by createZones().

bool ZWParser::readHTMLPref | ( | MWAWEntry const & | entry | ) |

protected

read the html export pref

Referenced by createZones().

bool ZWParser::readPrintInfo | ( | MWAWEntry const & | entry | ) |

protected

read a PrintInfo block

Referenced by createZones().

bool ZWParser::readSectionRange | ( | MWAWEntry const & | entry | ) |

protected

read the section range block

Referenced by createZones().

bool ZWParser::readSLen | ( | MWAWEntry const & | entry | ) |

protected

read a section length ?

Referenced by createZones().

bool ZWParser::readUnknownZone | ( | MWAWEntry const & | entry | ) |

protected

read a unknown block

Referenced by createZones().

bool ZWParser::readWindowPos | ( | MWAWEntry const & | entry | ) |

protected

read the window position

Referenced by createZones().

libmwaw::DebugFile & ZWParser::rsrcAscii | ( |  | ) |

protected

a DebugFile used to write what we recognize when we parse the document in rsrc

Referenced by readBarState(), readCPos(), readCPRT(), ZWText::readHFZone(), readHTMLPref(), readPrintInfo(), ZWText::readSectionFonts(), readSectionRange(), readSLen(), ZWText::readStyles(), readUnknownZone(), readWindowPos(), and ZWText::sendText().

MWAWInputStreamPtr ZWParser::rsrcInput | ( |  | ) |

protected

return the input input

Referenced by ZWText::computePositions(), getFieldList(), readBarState(), readCPos(), readCPRT(), ZWText::readHFZone(), readHTMLPref(), readPrintInfo(), ZWText::readSectionFonts(), readSectionRange(), readSLen(), ZWText::readStyles(), readUnknownZone(), readWindowPos(), ZWText::sendHeaderFooter(), sendHeaderFooter(), and ZWText::sendText().

bool ZWParser::sendHeaderFooter | ( | bool | header | ) |

protected

try to send the header/footer

## Friends And Related Function Documentation

friend class ZWParserInternal::SubDocument

friend

friend class ZWText

friend

Referenced by init().

## Member Data Documentation

shared_ptr<ZWParserInternal::State> ZWParser::m_state

protected

the state

Referenced by checkHeader(), createDocument(), getPageLeftTop(), init(), and newPage().

shared_ptr<ZWText> ZWParser::m_textParser

protected

the text parser

Referenced by createDocument(), createZones(), init(), parse(), and sendHeaderFooter().

The documentation for this class was generated from the following files:

- ZWParser.hxx
- ZWParser.cxx